\name{NEWS}
\title{News for Package 'roxyPackage'}
\encoding{UTF-8}
\section{Changes in roxyPackage version 0.06-3 (2018-05-07)}{
  \subsection{fixed}{
    \itemize{
      \item \code{roxy.package()}: fixed a HTML issue introduced with the html.options
        \code{"imprint"} and \code{"privacy.policy"}
    }
  }
}
\section{Changes in roxyPackage version 0.06-2 (2018-05-06)}{
  \subsection{fixed}{
    \itemize{
      \item \code{roxy.package()}: use "el-capitan" as the default symlink for macOS repos
      \item \code{roxy.package()}: unset some environment variables that might cause trouble
        if building for multiple R versions
    }
  }
  \subsection{added}{
    \itemize{
      \item \code{roxy.package()}: new html.options \code{"imprint"} and \code{"privacy.policy"} to add
        links to respective pages from your repo
    }
  }
}
\section{Changes in roxyPackage version 0.06-1 (2018-03-08)}{
  \subsection{fixed}{
    \itemize{
      \item \code{debianize()}: worked around a bug in \code{utils::tar()} rendering it almost
        useless
      \item fixed a really dumb bug in \code{archive.packages()} setting the PGP key to 2 by
        default for \code{"deb"} archives
    }
  }
  \subsection{changed}{
    \itemize{
      \item the package now needs at least R >= 3.0.0, all code fragments which tried
        to keep supporting R 2.14 and even earlier were removed. no-one should
        use that any longer
      \item the arguments 'html.index' and 'html.title' were moved to 'index' and
        'title' of a new option list called 'html.options' for more consistency; old
        code should still work for the time being, but trigger a warning -- please
        update your scripts!
      \item cleaned up dependencies, now using mostly imports instead
      \item set debhelper default dependency to >> 9.0.0 (instead of >> 7.0.0)
      \item worked around the news2Rd issue by copying the function to the internal
        namespace
      \item there's also no longer a need to call private functions from the XiMpLe
        package
      \item replaced private function \code{last.dir.name()} with base function \code{basename()}
      \item repo: changed the way symlinks are set for macOS; we're now creating the
        top level directory and link to ../contrib, to work around issues with
        infinite link loops; this does not affect existing repos, only new ones
      \item since Flattr totally changed its API and stuff, the Flattr integration
        was updated. no more buttons will be generated, instead a meta tag is added
        to HTML and/or markdown documents. this also means you need to remove the
        'flattrUser' value from 'readme.options' and add your meta tag ID to the
        new 'html.options' for this to work correctly
      \item vignette is now in RMarkdown/HTML format; the SWeave/PDF version was
        dropped
    }
  }
  \subsection{added}{
    \itemize{
      \item \code{rnw2rmd()}: new function that tries to convert Sweave vignettes into R
        markdown
      \item \code{package_description()}: new function to make it easier to generate proper
        package description objects (prevent typos, demand mandatory fields, value
        checks)
      \item \code{debianize()}: explain in the docs that setting a package in
        \code{"depends.origin.alt"} to NULL will enable you to provide the full R debian package name
      \item \code{roxy.html()}: URLs in the form of "(... <...>)" are now automatically
        turned into <a href> nodes; i hope the parser doesn't introduce new issues
      \item \code{roxy.html()}: fields \code{"Additional_repositories"} and \code{"NeedsCompilation"} are
        now also evaluated
      \item \code{roxy.package()}: vignette generation now takes an existing .install_extras
        file into account when moving/copying files
      \item \code{roxy.package()}: new action \code{"vignette"} can be used to generate an initial
        vignette stub file
      \item \code{roxy.package()}: new action \code{"buildVignettes"} forces rebuilding all
        vignettes during the \code{"package"} action, to make sure a proper vignette index is
        present in the source tarball; this was made configurable via its own action
        because it is a bit time consuming during builds and usually only
        neccessary for actual releases
    }
  }
}
\section{Changes in roxyPackage version 0.05-3 (2017-06-09)}{
  \subsection{fixed}{
    \itemize{
      \item \code{debianize()}: the \code{"append"} feature for dependencies in was broken
      \item \code{archive.packages()} now defaults to gpg2 as well
      \item \code{debianize()}: the HTML instructions look pretty again, worked around a
        layout problem caused by XiMpLe's auto-indentation in <pre> tags
      \item \code{roxy.package()}: internal use of \code{tools::getVignetteInfo()} was unaware of
        custom R libs.
      \item added robert nuske as an official contributor to the package
    }
  }
  \subsection{changed}{
    \itemize{
      \item R versions older that 3.0 should no longer be around (it was released
        four years ago). support for these older versions will be removed in one of
        the future releases. for now, a warning is shown, announcing that use with
        R <3.0 is deprecated
      \item \code{debianize()}: the R version used for build dependencies in \code{"control"} is
        now taken from DESCRIPTION by default, not the current version
      \item \code{debianize()}: the package description in \code{"control"} is now similar to
        CRAN2deb
      \item cleaned up all tests, using two new/revised internal functions
        \code{roxyPackage:::generateTestPackage()} and \code{roxyPackage:::removeTestPackage()}
      \item updated vignette to include \code{templateFile()}
      \item \code{roxy.html()}: HTML page now lists all contributors indicating their roles
        (contributed by robert nuske)
      \item \code{roxy.package()}: checks should be done on built packages, the \code{"check"}
        action now throws a warning if checks are done on unpackaged sources (which is
        the case if you omit the \code{"package"} action)
      \item \code{roxy.html()}: we're now also including the comments of person objects
      \item \code{roxy.package()}: the README.md file generated by the \code{"readme"} action now
        flags the installation code as R syntax
      \item \code{debianize()}: bumped default compat level from 7 to 9 and added \code{"compat"}
        to the files that are updated by default
    }
  }
  \subsection{added}{
    \itemize{
      \item new function \code{templateFile()} to quickly generate new source file templates
        for functions, S4 classes and methods, including some hopefully useful
        defaults (copyright, roxygen documentation and code stubs)
      \item \code{roxy.package()}: the \code{"URL"} option can now also be a named list to be able
        to either host the debian repo on a different server, or to configure the
        use of a \code{"mirror.list"} and a custom \code{"debian.path"}
      \item \code{roxy.package()}: the HTML instructions for debian packages now also lists
        the package source files
      \item new EXPERIMENTAL feature: there are cases where \code{roxygenize()} somehow
        fails but e.g. \code{document()} of the devtools package doesn't. you can now use
        roxyPackage:::set.roxyEnv(name=\code{"roxyFunction"}, value=devtools::document) to
        overwrite the function that is being used to roxygenize the docs. use this
        with caution! it is experimental for a reason!
      \item \code{roxy.html()}: HTML page now also lists LinkingTo: and SystemRequirements:
        if present (contributed by robert nuske)
      \item \code{roxy.package()}: source and windows builds now also include an MD5 file
    }
  }
}
\section{Changes in roxyPackage version 0.05-2 (2017-02-26)}{
  \subsection{fixed}{
    \itemize{
      \item replaced some tilde characters in the vignette by \\textasciitilde
      \item debinanizing failed with certain versions of dpkg-parsechangelog
        expecting a space after "--count"
    }
  }
  \subsection{changed}{
    \itemize{
      \item added \code{"readme"} action to vignette
      \item changed the docs to suggest to give the most recent R version first in
        line when building for multiple versions. the debianizing is now also done
        during the first run
      \item internal function \code{GPGsign()} now forces both cert-digest-algo and
        digest-algo to be set to SHA256; for now, this is hard coded but could be made
        configurable if requested
      \item reaktanz.de supports HTTPS now, updated references
    }
  }
  \subsection{added}{
    \itemize{
      \item internal function \code{GPGsign()} is now also capable of generating InRelease
        files; they will automatically be added to debian repos from now on
      \item HTML page now also lists Imports and BugReports, which can either be a
        URL or mail address (contributed by robert nuske)
      \item if all of 'Date', 'Packaged', and 'Date/Publication' are missing in
        DESCRIPTION, pck.date will now be used as well (contributed by robert nuske)
      \item support for vignette types other than PDF (contributed by robert nuske)
    }
  }
}
\section{Changes in roxyPackage version 0.05-1 (2016-07-12)}{
  \subsection{fixed}{
    \itemize{
      \item R CMD check should be performed on built packages, not source
        directories. this is now the case if you run the \code{"check"} action also with \code{"package"}
        enabled
      \item fixed a path issue causing problems to find package sources when in full
        sandboxing mode, most importantly, this affected the internal function
        \code{prep.sndbx.source.dir()}
      \item normalized paths in internal function \code{mvToArchive()}, called by
        \code{archive.packages()}
      \item using \code{tools::package_dependencies()} instead of
        \code{tools::package.dependencies()} if R >= 3.3
      \item the \code{tar()} function of R produced broken archives with files added
        multiple times
    }
  }
  \subsection{changed}{
    \itemize{
      \item the code for checks was moved to the end of \code{roxy.package()}
      \item removed \code{deb.gen.changelog.old()}, it was unused since 0.04-2
      \item \code{debianize()} now generates machine-readable copyright files
      \item when \code{debianizeKeyring()} is called from \code{debianize()} or \code{roxy.rackage()}, it
        is now able to fetch the repo URL
      \item removed overwrite argument from internal function \code{deb.update.release()}
        because it actually didn't have any effect anyway
      \item revert back to adding standard LICENSE files instead of LICENSE.txt, as
        none of them are accepted on CRAN anyway
      \item code cleaning (loops)
      \item removed the internal package description (obsolete)
    }
  }
  \subsection{added}{
    \itemize{
      \item new action \code{"readme"} to generate an initial README.md file
      \item new action \code{"binonly"} to enable binary-only rebuilds
      \item HTML page now lists all found binary packages for a package if it is
        available for more than one R version in the repository
      \item \code{archive.packages()} can now also archive Debian repositories; it gained
        new arguments keep.revisions and deb.options for fine-tuning
      \item if readme.options contains a Flattr user and URL is set, a Flattr button
        will also be added to the repository HTML page
      \item \code{debianize()} has a new option keep.existing.orig to prevent binary-only
        rebuilds from overwriting existing *.orig.[gz|xz] archives
    }
  }
}
\section{Changes in roxyPackage version 0.04-4 (2016-02-04)}{
  \subsection{fixed}{
    \itemize{
      \item re-activated the unit tests that were shut down with 0.03-11 due to
        https://github.com/hadley/testthat/issues/86 as there's now a workaround fixing
        tests/testthat.R
      \item removed leftover tests/test_roxyPackage_package.R
      \item updated URL to roxygen2 in docs
      \item fixed title case in title field
      \item fixed imports in NAMESPACE file
    }
  }
  \subsection{changed}{
    \itemize{
      \item moved unit tests to tests/testthat
      \item added dch and dpkg-parsechangelog to dependecy checks of \code{debianize()}
      \item default section for debian R packages is now "gnu-r" instead of \code{"math"}
      \item \code{archive.packages()} now uses type \code{"mac.binary"} instead of the deprecated
        \code{"mac.binary.leopard"}
    }
  }
  \subsection{added}{
    \itemize{
      \item new option \code{"OSX.repo"} to deal with the constantly changing paths of
        binary repos for max OS X
    }
  }
}
\section{Changes in roxyPackage version 0.04-3 (2015-06-29)}{
  \subsection{fixed}{
    \itemize{
      \item internal function \code{parseChangeLog()} now checks for proper version and date
        information and throws an error if one is missing, as suggested by robert
        nuske
      \item making sure the \code{"inst"} directory exists before trying to copy a NEWS.Rd
        file there
    }
  }
}
\section{Changes in roxyPackage version 0.04-2 (2015-03-05)}{
  \subsection{fixed}{
    \itemize{
      \item debian packages with a dot in their names were overlooked when it came to
        generating the HTML docs
      \item somehow a wrong release date for 0.03-12 sneaked into the ChangeLog...
      \item newlines in DESCRIPTION caused \code{debianize()} to misread dependency
        information and quit with an error
      \item roxygen2 can produce too long comment lines in Rd file heads; using
        \code{"cleanRd"} on this resulted in broken Rd files because the comment char was
        missing
    }
  }
  \subsection{changed}{
    \itemize{
      \item removed the options \code{"local.roxy.dir"} and \code{"roxy.unlink.target"} from
        \code{roxy.package()}, as their counterparts are no longer supported by roxygen2. if
        you still need those options (working with ancient roxygen2 versions), use
        \code{"roxygen.dir"} and \code{"unlink.target"} in \code{"..."} instead
      \item removed the workaround call to \code{roxygen2:::source_package()} as well, it
        doesn't seem to be necessary any longer
      \item \code{roxy.package()} now uses "--install-tests" as default option for "R CMD
        install"
      \item \code{debianize()} now passes \code{"build.dir"} on to \code{debianizeKeyring()} as a default
      \item \code{debianize()} now uses dch and dpkg-parsechangelog to manage
        debain/changelog, which is much more robust than the previous construction
    }
  }
  \subsection{added}{
    \itemize{
      \item a new RKWard plugin allows you to really quickly get started with your
        own roxyPackage script
      \item basic support for \code{"cph"} (copyright holder) field in author roles
    }
  }
}
\section{Changes in roxyPackage version 0.04-1 (2014-06-14)}{
  \subsection{fixed}{
    \itemize{
      \item \code{tools::buildVignettes()} doesn't produce PDFs if they are already present;
        remove present PDFs, if the \code{"doc"} action is active. the vignettes
        creation was reworked to deal with vignettes directories more smoothly, e.g.
        create inst/doc and copy results and sources there
      \item \code{debianize()} didn't auto-append default dependencies correctly
      \item docs of \code{debianize()} falsely still said that source packaging wasn't
        implemented
      \item example in \code{debianize()} showed description in lowercase, which wouldn't
        work
      \item \code{debianize()} didn't get multiple authors quite all right
      \item the copyright file generated by \code{debianize()} missed out the homepage and
        overwrite rule
      \item signature changes to \code{roxygenize()} in roxygen2 >= 4.0.0 are now implemented
      \item the logic to remove build directories for debian packages could have
        dangerous consequences if you chose them unwise; now, the directory will only
        be removed if it was empty before the build process
    }
  }
  \subsection{changed}{
    \itemize{
      \item \code{debianize()} gained the new argument \code{"repo.name"}, used for generating a
        debian package from the OpenPGP key used for secure apt. you should set this
        to something different from the default if you plan to actually publish
        the repository -- if you don't, you'll get a warning
      \item expect gpg2 as the default (earlier versions defaulted to gpg)
      \item moved code for generation of several debian package files into autonomous
        internal functions
      \item suppressed the LaTeX output, so the console messages are more
        comprehensible
      \item in the sources, moved definition of classes and methods to files with
        more speaking names
      \item removed the temporary hack to test roxygen3, since roxygen2 4.x is
        already released and runs out-of-the-box with this version of roxyPackage
      \item source packages for debian now default to xz compression
    }
  }
  \subsection{added}{
    \itemize{
      \item new function \code{debianizeKeyring()} can generate debian packages from OpenPGP
        keys
      \item new argument \code{"compression"} for \code{debianize()}
    }
  }
}
\section{Changes in roxyPackage version 0.03-12 (2014-03-15)}{
  \subsection{fixed}{
    \itemize{
      \item \code{tools::pkgVignettes()} and \code{tools::buildVignettes()} stopped working without
        an existing DESCRIPTION file. working around that by moving the calls to
        a place where the file should be present already
      \item added a workaround for roxygen2 >= 3.0.0, calling
        \code{roxygen2:::source_package()} to overcome unsolved issues with its S4 implementation
    }
  }
  \subsection{changed}{
    \itemize{
      \item managed to remove some of the \code{setwd()} calls, but some don't seem to be
        replaceable as of now. this seems to trigger the problems with the unit
        tests, so they remain deactivated in tests/ test_roxyPackage_package.R, but
        have been revived in inst/tests/test,R
      \item added a proper GPL notice at the beginning of each R file
      \item replaced all tabs in the source code by two space characters
    }
  }
}
\section{Changes in roxyPackage version 0.03-11 (2013-10-27)}{
  \subsection{fixed}{
    \itemize{
      \item another attempt to fix the \code{.find.package()} issue (see log for 0.03-5), as
        suggested by kurt hornik
      \item typo in docs to \code{debianize()} corrected (\code{"epoch"} instead of \code{"Epoch"})
      \item \code{dep4deb()} now always returns $dl as a matrix
      \item "--no-vignettes" is deprecated as of R 3.0.0, replaced with
        "--no-build-vignettes"
      \item corrected some ::: operators into ::
      \item new action \code{"cleanRd"} checks for lines longer than 90 chars in Rd files
        and adds automatic line breaks (with a warning). otherwise R CMD check would
        complain and the package wouldn't be accepted on CRAN. this is actually a
        workaround for a bug in roxygen2, regarding automatically generated usage
        sections
      \item in the generated DESCRIPTION file, authors and contributors will no
        longer be listed with their e-mail address, just plain names
      \item sandboxing and running the \code{"check"} action now also copies suggested
        packages to the sandbox folders if neccessary
    }
  }
  \subsection{removed}{
    \itemize{
      \item removed the unit tests for this release, because they suddenly stopped
        working with "R CMD check" (while still running fine from an R session).
        i.e., it's not that the tests themselves fail, but the testthat package stops
        with yet mysterious errors. i filed a report, hope this can be solved
        soon: https://github.com/hadley/testthat/issues/86
    }
  }
  \subsection{changed}{
    \itemize{
      \item the vignette was moved from inst/doc to inst/vignettes
      \item some lines in the docs were too long and have been shortened
      \item internal function \code{autoLineBreak()} returns a nameless character vector now
      \item beginning with this version, roxyPackage is no longer hosted on CRAN. its
        policies and checks have become more strict over time, and since the
        alternative would have been to reduce this package's features to remain in
        full compliance, i decided to have the package removed instead. the problem
        is this: the NEWS.Rd related features rely on calls to the internal
        function \code{tools:::news2Rd()}, as is even recommended in the manual to \code{news()}; CRAN
        doesn't allow this use of an internal functions, even if it's exactly what
        the R docs say.
    }
  }
  \subsection{added}{
    \itemize{
      \item another EXPERIMENTAL feature: call
        'roxyPackage:::set.roxyEnv(name=\code{"Rdevel"}, value=TRUE)' and 'roxyPackage:::set.roxyEnv(name=\code{"Rversion"},
        value=\code{"x.y.z"})' to manually set an arbitrary R version string to be able to build
        against bleeding edge R-devel installations
      \item new \code{roxy.package()} arguments \code{"Rbuildignore"} and \code{"Rinstignore"} can be used
        to control .Rbuildignore and .Rinstignore files, respectively
    }
  }
}
\section{Changes in roxyPackage version 0.03-10 (2013-06-11)}{
  \subsection{added}{
    \itemize{
      \item \code{debianize()}: support for epoch in debian package versioning
      \item \code{debianize()}: support for appending package dependencies rather than
        replacing the automatically found
      \item \code{debianize()}: support for arbitrary fields in \code{"deb.description"}
    }
  }
  \subsection{fixed}{
    \itemize{
      \item the *-package.R file used to contain an alias of the package name alone,
        which would cause trouble if there's a function or similar by the same
        name/alias. now only the alias '<package name>-package' will be included.
    }
  }
}
\section{Changes in roxyPackage version 0.03-9 (2013-05-10)}{
  \subsection{fixed}{
    \itemize{
      \item internal function \code{dateRFC2822()} now always forces LC_TIME into locale \code{"C"}
        temporarily, instead of trying to use "en_GB.UTF-8" (which is not
        available on all machines). this small function is needed for timestamps in
        Debian changelogs
      \item fixed the split-up of debinaizing actions for multiple R installations:
        the previous implementation accidently dropped package building completely
    }
  }
  \subsection{added}{
    \itemize{
      \item new function \code{dep4deb()} can recursively download dependencies for a given
        package. this is still in its early stages and probably buggy, and i am
        also considering placing all Debian related functionality into a package of
        its own (which would become a dependency of roxyPackage), soon.
    }
  }
}
\section{Changes in roxyPackage version 0.03-8 (2013-05-07)}{
  \subsection{fixed}{
    \itemize{
      \item due to a silly bug, \code{debianize()} usually ignored the fields \code{"Homepage"} and
        \code{"Essential"} for the control file
    }
  }
  \subsection{added}{
    \itemize{
      \item \code{debianize()} can now try to build a valid debian package directly from
        arbitrary package sources; it will try to generate plausible dependencies
        from the R package names provided in DESCRIPTION
      \item \code{debianize()} does also try to include package \code{"Suggests"} automagically
      \item added some basic unit tests, using the testthat package
    }
  }
  \subsection{changed}{
    \itemize{
      \item the default \code{"origin"} value of \code{debianize()} has been changed from \code{"other"}
        to "other-roxypackage"
      \item \code{debianize()} now adds dependecies to r-base-core (instead of r-base) and
        debhelper >= 7.0.0 (instead of >= 4.1.0) if none are given
      \item \code{debianize()} doesn't set the maintainer of upstream as the debian package
        maintainer by default any longer, but generates a maintainer ID from
        system information and throws a warning. this should encourage everyone to set
        at least valid maintainer information manually
      \item if multiple R installations are provided, the \code{"deb"} action will be split
        up: debianizing the sources will be done during first run, but package
        building during the last
    }
  }
}
\section{Changes in roxyPackage version 0.03-7 (2013-04-16)}{
  \subsection{fixed}{
    \itemize{
      \item OS X binary packages for R >= 3.0.0 will now be stored in
        $REPOSITORY/bin/macosx/contrib, and no longer in $REPOSITORY/bin/macosx/leopard/contrib
    }
  }
}
\section{Changes in roxyPackage version 0.03-6 (2013-04-07)}{
  \subsection{added}{
    \itemize{
      \item \code{debianize()} now supports both strict package names according to the
        Debain R Policy as well as package names with a dot, whichever is expected by
        your r-cran.mk file. Ignoring the policy is the default, as that is the
        de-facto standard.
    }
  }
}
\section{Changes in roxyPackage version 0.03-5 (2013-03-30)}{
  \subsection{fixed}{
    \itemize{
      \item .\code{find.package()} will soon be removed from R, replaced it with
        \code{find.package()} for R >= 2.13
    }
  }
}
\section{Changes in roxyPackage version 0.03-4 (2013-03-12)}{
  \subsection{changed}{
    \itemize{
      \item internally replaced paste(..., sep=\code{""}) with paste0(...), and added a
        version dependent wrapper for compatibility with R < 2.15
    }
  }
  \subsection{added}{
    \itemize{
      \item AGPL and Artistic License 2.0 have been added to the common licenses
    }
  }
  \subsection{fixed}{
    \itemize{
      \item license files are now called LICENSE.txt; this is to prevent their
        installation, as suggested by 'Writing R Extensions'
    }
  }
}
\section{Changes in roxyPackage version 0.03-3 (2013-02-13)}{
  \subsection{added}{
    \itemize{
      \item extended sandboxing possibilities to \code{archive.packages()} and \code{debianize()}
    }
  }
  \subsection{changed}{
    \itemize{
      \item \code{sandbox()} will now remove all paths set if \code{"active"} is FALSE
    }
  }
}
\section{Changes in roxyPackage version 0.03-2 (2013-02-11)}{
  \subsection{added}{
    \itemize{
      \item new sandbox feature, see ?\code{sandbox()} and ?\code{sandbox.status()}. this needs
        testing, and future releases will get support for this in all relevant
        functions, not just \code{roxy.package()}, as it is now.
    }
  }
}
\section{Changes in roxyPackage version 0.03-1 (2013-01-29)}{
  \subsection{changed}{
    \itemize{
      \item split documentation for ChangeLog functions and methods
    }
  }
  \subsection{added}{
    \itemize{
      \item there is now an EXPERIMENTAL option to be able to toy around with
        roxygen3: call 'roxyPackage:::set.roxyEnv(name=\code{"roxygenVersion"}, value=3)' to
        enable some hidden features, i.e. use \code{roxygen3::roxygenise()} instead of
        \code{roxygen2::roxygenize()}. you need to install and load the roxygen3 package first
        -- temper with this at your own risk. please note: there will probably
        never be an official roxygen3 package on CRAN, and once its features were
        merged into roxygen2, this option might be patched out of roxyPackage again.
      \item this is the first version of roxyPackage supposed to be released on CRAN
    }
  }
}
\section{Changes in roxyPackage version 0.02-23 (2013-01-25)}{
  \subsection{changed}{
    \itemize{
      \item updated vignette
    }
  }
  \subsection{fixed}{
    \itemize{
      \item debian installation notes will not be linked from a package's HTML page
        if there is no built debian package in the repository
    }
  }
}
\section{Changes in roxyPackage version 0.02-22 (2012-10-30)}{
  \subsection{changed}{
    \itemize{
      \item the title for *-package.R files now states "The <package name> Package"
        instead of the Title: entry from the description
    }
  }
  \subsection{fixed}{
    \itemize{
      \item order of ChangeLog entries is now checked, so that the newest entries get
        on top
    }
  }
}
\section{Changes in roxyPackage version 0.02-21 (2012-10-14)}{
  \subsection{added}{
    \itemize{
      \item new action \code{"log"} generates an initial ChangeLog, if none is found
      \item introducing new functions \code{initChangeLog()}, \code{readChangeLog()},
        \code{writeChangeLog()}, as well as the methods \code{getChangeLogEntry()} and \code{updateChangeLog()}.
        they are probably not bug-free, but should ease the management of proper R
        ChangeLogs considerably.
    }
  }
  \subsection{changed}{
    \itemize{
      \item this ChangeLog was read-in by \code{readChangeLog()}, updated with the log
        entries for this release by \code{updateChangeLog()}, and written back with
        \code{writeChangeLog()}.
    }
  }
}
\section{Changes in roxyPackage version 0.02-20 (2012-09-29)}{
  \subsection{fixed}{
    \itemize{
      \item contributors in Author@R/Authors@R fields are now also added to
        *-package.R and DESCRIPTION
      \item the \code{"check"} option "--as-cran" is automatically stripped for R < 2.15
    }
  }
}
\section{Changes in roxyPackage version 0.02-19 (2012-09-09)}{
  \subsection{changed}{
    \itemize{
      \item the \code{"check"} action now has "--as-cran" set as the default option
    }
  }
  \subsection{added}{
    \itemize{
      \item the \code{"doc"} action now also supports \code{"vignette"} subdirectories in addition
        to "inst/doc" for vignette files
      \item added new function \code{archive.packages()} to move old versions of packages to
        an archive directory, or to remove them for good. since this is
        potentially dangerous and needs some rounds of testing, its \code{"reallyDoIt"}-option
        needs to be set to TRUE manually, otherwise a dry run is done, i.e., all
        actions are only printed and not done, so you can check the outcome first.
    }
  }
}
\section{Changes in roxyPackage version 0.02-18 (2012-07-30)}{
  \subsection{fixed}{
    \itemize{
      \item using \code{shortPathName()} to fix problems on windows caused by the path
        normalization introduced with 0.02-17 (thanks to henrik singmann for tracking
        this one down)
    }
  }
  \subsection{changed}{
    \itemize{
      \item wrote some new internal helper functions, namely \code{createMissingDir()} and
        \code{removeIfExists()}, and replaced their manual pendants in the \code{roxy.package()}
        code, which is now easier to read
    }
  }
}
\section{Changes in roxyPackage version 0.02-17 (2012-07-20)}{
  \subsection{fixed}{
    \itemize{
      \item the tar option "--exclude-vcs" is not always implemented, especially not
        in the BSD tar of Mac OS X; so excluding version control directories is
        now done in a more manual manner in roxyPackage
      \item also, on Mac OS X the tar binary is now identified using Sys.which(\code{"tar"})
      \item finally, "--exclude=*~" caused trouble if path names contained a tilde
        for $HOME, so this was replaced with a more reliable way to exclude backup~
        files as well
      \item all root paths are now normalized before first use, especially to perform
        tilde expansion, because this lead to errors with \code{tar()}
    }
  }
}
\section{Changes in roxyPackage version 0.02-16 (2012-07-12)}{
  \subsection{fixed}{
    \itemize{
      \item HTML generation now also works if there's no "Author:" field in the
        DESCRIPTION
    }
  }
}
\section{Changes in roxyPackage version 0.02-15 (2012-06-10)}{
  \subsection{changed}{
    \itemize{
      \item the data.frame with the package description doesn't need to have entries
        for \code{"Author"} or \code{"Maintainer"} any more, as long as "Authors@R" is present
    }
  }
}
\section{Changes in roxyPackage version 0.02-14 (2012-06-05)}{
  \subsection{fixed}{
    \itemize{
      \item roxyPackage now supports multiple vignette files in one package
      \item fixed problems if the repository isn't on the same file system as the
        sources
    }
  }
}
\section{Changes in roxyPackage version 0.02-13 (2012-05-12)}{
  \subsection{fixed}{
    \itemize{
      \item fixed malformed BibTeX entry in CITATION if more than one author given
    }
  }
}
\section{Changes in roxyPackage version 0.02-12 (2012-05-11)}{
  \subsection{fixed}{
    \itemize{
      \item line breaks were missing in repo HTML, which lead to malformed <pre>
        sections
      \item debian repo information will now generally be prepared for binary and
        source packages
    }
  }
}
\section{Changes in roxyPackage version 0.02-11 (2012-04-29)}{
  \subsection{added}{
    \itemize{
      \item added a vignette
      \item \code{debianize()} now creates debian/compat, by default set to level 7
    }
  }
  \subsection{changed}{
    \itemize{
      \item status messages are more consistent now
      \item the link to a debian binary package moved from the general package HTML
        page to the debian repository info page
    }
  }
}
\section{Changes in roxyPackage version 0.02-10 (2012-04-19)}{
  \subsection{added}{
    \itemize{
      \item \code{debianize()} now checks if a given GnuPG key is already available as a
        file in the repository, and if not, saves is as <key ID>.asc
      \item the \code{"html"} action now also adds auto-generated information on how to
        install debian packages from the maintained repository
    }
  }
}
\section{Changes in roxyPackage version 0.02-9 (2012-04-15)}{
  \subsection{added}{
    \itemize{
      \item this is the first package, along with its dependecies, which is also
        available as a debian package build with roxyPackage
    }
  }
  \subsection{changed}{
    \itemize{
      \item if information is to be fetched from a DESCRIPTION file and there is no
        \code{"Date"} field, \code{roxy.package()} considers \code{"Packaged"} and then
        "Date/Publication" as fallback alternatives (and throws a warning)
      \item the actions \code{"deb"}, \code{"roxy"}, \code{"cite"}, \code{"license"}, \code{"doc"}, \code{"cl2news"} and
        \code{"news2rss"} are now only run once for builds against multiple R installations,
        because their outcome should be the same anyway
    }
  }
  \subsection{fixed}{
    \itemize{
      \item 'deb.options' are now also passed to recursive calls of \code{roxy.package()},
        although there's still no solution for actual builds against multiple R
        installations
    }
  }
}
\section{Changes in roxyPackage version 0.02-8 (2012-04-14)}{
  \subsection{added}{
    \itemize{
      \item \code{roxy.package()} now checks for needed fields in DESCRIPTION, if that file
        is used to get info on the package, and throws an error if something is
        missing
      \item installation now includes common-licenses.zip
      \item \code{roxy.package()} has a new action \code{"license"} to detect the package license
        and save a copy of common free software licenses as the package's LICENSE
        file
    }
  }
  \subsection{changed}{
    \itemize{
      \item added hints on dependencies to the \code{debianize()} docs
    }
  }
  \subsection{fixed}{
    \itemize{
      \item regex to get author info without e-mail address for debian/copyright now
        works with multiple authors
      \item fixed some formatting issues with debian/copyright
    }
  }
}
\section{Changes in roxyPackage version 0.02-7 (2012-04-11)}{
  \subsection{added}{
    \itemize{
      \item \code{debianize()} can now sign Release files with GnuPG
      \item \code{roxy.package()} has a new action \code{"deb"} and a new parameter 'deb.options',
        to invoke \code{debianize()} directly
      \item debian packages are now added to the html index files
    }
  }
  \subsection{changed}{
    \itemize{
      \item Release files in \code{debianize()} are now generated with apt-ftparchive
      \item \code{debianize()} talks a little more about what it's busy with
      \item debian package dependencies now detect R version for "r-base" and
        "r-base-dev"
    }
  }
  \subsection{fixed}{
    \itemize{
      \item debian package dependencies now default to "r-base" instead of
        "r-base-dev"
    }
  }
}
\section{Changes in roxyPackage version 0.02-6 (2012-04-10)}{
  \subsection{added}{
    \itemize{
      \item initial (and rather experimental...) support for debianizing packages
        with the \code{debianize()} function
    }
  }
  \subsection{changed}{
    \itemize{
      \item internal function \code{dateRFC2822()} now does the date conversion for
        \code{news2rss()}
    }
  }
}
\section{Changes in roxyPackage version 0.02-5 (2012-04-07)}{
  \subsection{added}{
    \itemize{
      \item generated index.html pages now have a generator meta tag, like the RSS
        feeds
    }
  }
  \subsection{fixed}{
    \itemize{
      \item removed initial tabulator in BibTeX entries of generated citation.html
    }
  }
}
\section{Changes in roxyPackage version 0.02-4 (2012-04-06)}{
  \subsection{fixed}{
    \itemize{
      \item \code{zip()} should now *really* ignore backup files (ending with a tilde)
    }
  }
  \subsection{changed}{
    \itemize{
      \item 'cleanup=TRUE' now recursively removes backup files in the source
        directory
    }
  }
}
\section{Changes in roxyPackage version 0.02-3 (2012-04-05)}{
  \itemize{
    \item using Rd2pdf instead of Rd2dvi for R >= 2.15 now; in 'Rcmd.options',
      Rd2dvi will still be recognized, though
    \item \code{zip()} should now ignore backup files (ending with a tilde)
  }
}
\section{Changes in roxyPackage version 0.02-2 (2012-03-18)}{
  \itemize{
    \item RSS feeds in HTML header now also state the package name (action \code{"html"})
    \item re-wrote HTML genrating functions, now all is done use XiMpLe methods
  }
}
\section{Changes in roxyPackage version 0.02-1 (2012-03-14)}{
  \itemize{
    \item added new function \code{news2rss()} to write RSS feeds (XML) from
      NEWS.Rd/NEWS.html files
    \item action \code{"html"} now adds the RSS feed for a package to the HTML header and
      news link
    \item exported a new function, \code{cl2news()}, which now carries out the action by
      the same name, but can also used stand-alone
    \item added dependency to the XiMpLe package to make the handling of all
      HTML/XML stuff easier
    \item removed \code{"target"} attributes from HTML anchors to comply with XHTML 1.0
      strict
  }
}
\section{Changes in roxyPackage version 0.01-20 (2012-03-11)}{
  \itemize{
    \item action \code{"html"} now also writes an index.html file to the repository root
      directory
  }
}
\section{Changes in roxyPackage version 0.01-19 (2012-03-10)}{
  \itemize{
    \item added option to manually specify options to the internal R CMD calls to
      \code{roxy.package()}
    \item fixed build for multiple R homes, now using R CMD INSTALL instead of
      \code{install.packages()}
    \item OS is now checked and on Windows \code{shell()} is used instead of \code{system()}
    \item fixed broken \code{"check"} action on Windows
    \item added action \code{"cl2news"} to transform ChangeLogs into NEWS.Rd
    \item action \code{"html"} now transforms inst/NEWS.Rd into NEWS.html and links this
      in index.html, if found
    \item replaced unicode symbols in \code{entities()} with \\uxxxx ASCII escapes
  }
}
\section{Changes in roxyPackage version 0.01-18 (2012-02-09)}{
  \itemize{
    \item removed null function \code{roxygen()} from package description files, NULL
      alone is sufficient in roxygen2
  }
}
\section{Changes in roxyPackage version 0.01-17 (2012-01-04)}{
  \itemize{
    \item fixed a problem with line breaks in author information (e.g., for
      multiple contributors)
  }
}
\section{Changes in roxyPackage version 0.01-16 (2011-11-21)}{
  \itemize{
    \item repo directory is now checked and created automatically from the start
      (thanks to natalia belgorodski for reporting the issue)
  }
}
\section{Changes in roxyPackage version 0.01-15 (2011-11-10)}{
  \itemize{
    \item added support for HTML citation info
    \item added function \code{entities()}, mainly to scramble mail adresses
    \item html package info now also links to ChangeLog, if found
    \item fixed typo in html descriptions (some missing colons)
  }
}
\section{Changes in roxyPackage version 0.01-14 (2011-11-09)}{
  \itemize{
    \item \code{roxy.package()} now tries to read DESCRIPTION if pck.description=NULL
  }
}
\section{Changes in roxyPackage version 0.01-13 (2011-11-08)}{
  \itemize{
    \item added support to create HTML index pages to list available packages
  }
}
\section{Changes in roxyPackage version 0.01-12 (2011-10-20)}{
  \itemize{
    \item \code{roxy.package()} now tries to get every descriptive information from
      DESCRIPTION if actions don't include \code{"roxy"}
  }
}
\section{Changes in roxyPackage version 0.01-11 (2011-10-04)}{
  \itemize{
    \item \code{roxy.package()} now uses version number and date from DESCRIPTION if
      actions don't include \code{"roxy"}
  }
}
\section{Changes in roxyPackage version 0.01-10 (2011-09-23)}{
  \itemize{
    \item further tweaked handling of Authors@R for CITATION files
  }
}
\section{Changes in roxyPackage version 0.01-9 (2011-09-17)}{
  \itemize{
    \item added support for manual setting of R.home
  }
}
\section{Changes in roxyPackage version 0.01-8 (2011-09-16)}{
  \itemize{
    \item enhanced handling of Authors@R for CITATION files
  }
}
\section{Changes in roxyPackage version 0.01-7 (2011-09-11)}{
  \itemize{
    \item added support for "Authors@R", as needed by R >= 2.14
    \item added support for different \code{"Type"} values in DESCRIPTION
  }
}
\section{Changes in roxyPackage version 0.01-6 (2011-09-01)}{
  \itemize{
    \item added package check action
    \item added option to keep/remove vignette PDF in source package
  }
}
\section{Changes in roxyPackage version 0.01-5 (2011-08-22)}{
  \itemize{
    \item updated docs
  }
}
\section{Changes in roxyPackage version 0.01-4 (2011-08-21)}{
  \itemize{
    \item fixed a path bug in \code{roxy.package()}
  }
}
\section{Changes in roxyPackage version 0.01-3 (2011-08-18)}{
  \itemize{
    \item added support for "Author@R" and CITATION files
  }
}
\section{Changes in roxyPackage version 0.01-2 (2011-08-17)}{
  \itemize{
    \item added tools dependency to use \code{write_PACKAGES()}
    \item added mac OS X support (pure R only)
  }
}
\section{Changes in roxyPackage version 0.01-1 (2011-08-14)}{
  \itemize{
    \item initial release via reaktanz.de
  }
}
